/*         .c                       freeware                   xhunga@tiscali.fr
*/
/* --------------------------------- INCLUDES ------------------------------- */
#include "xa_hfile.h"
#include "fg2c.h"

/* --------------------------------- MAIN ----------------------------------- */
int main(void)
{
double (*P_f)(double x);
double (*P_g)(double x);

   int    n =   2*1000;
double    a =       1.;
double    b =       2.;
double   dx =       .1;
double step =     .001;
double    M =       0.;
/*-------------------------------- PROGRAM ---------------------------------- */


 clrscrn();
 printf(" Compute the volume of a solid of revolution,\n");
 printf(" generated by revolving R about the y-axis,  \n");
 printf(" by using cylindrical shells.                \n\n");
 printf(" Draw the region R bounded by the graph of f,\n");
 printf(" the graph of g,and x = a and x = b          \n\n");

 printf(" Let  f >=0 and g >=0 be continous on [%.3lf,%.3lf].\n\n", a, b);
 printf(" f : x-> %s\n\n", feq);
 printf(" g : x-> %s\n\n", geq);
 printf(" To see the graphs, open the file \"f_Df.plt\" with Gnuplot.\n\n");

             P_f = f;
             P_g = g;          /* plot [xmin:xmax] [ymin:ymax] */
            gplt_fgab(-3,     /* xmin  */
                       3,     /* xmax  */
                       0,     /* ymin  */
                     3.5,     /* ymax  */
                       a,
                       b,
                     feq,
                     geq,
           (*P_f),
           (*P_g)
                       );
 getchar();

 clrscrn();
 printf(" Draw a typical vertical rectangle. \n\n");
 printf(" To see the graph, open the file \"f_Df.plt\" with Gnuplot.\n\n\n\n\n");

 printf(" Thickness of shell :  dx\n");
 printf(" Average radius     : (%s)       \n", heq);
 printf(" Altitude           : (%s) - (%s)\n", feq, geq);
 printf(" The volume         :  2 Pi (%s) [(%s) - (%s)] dx\n\n\n",heq, feq, geq);
 printf(" Volume of a cylindrical shell = 2Pi(average radius)(altitude)(thickness)");
 printf(" \n\n\n\n\n");

              P_f = f;
              P_g = g;           /* plot [xmin:xmax] [ymin:ymax] */
gplt_SolidRevolCylindShellfg
                     (-3,     /* xmin  */
                       3,     /* xmax  */
                       0,     /* ymin  */
                     3.5,     /* ymax  */
                        a,
                        b,
                       dx,
                     step,
                   (*P_f),
                   (*P_g)
                       );
 getchar();

 clrscrn();
 printf(" If we apply \n\n\n");
 printf("    (%.3lf\n", a);
 printf(" int(      \n");
 printf("    (%.3lf%\n\n\n", b);

 printf(" to  : 2 * Pi (%s) [(%s) - (%s)] dx\n\n\n",
                     heq,   feq,  geq);
 printf(" We obtain a limit of sums of volumes of cylindrical shells.\n\n\n");

               P_f = VCylindricalShell;
 M = simpson((*P_f),a,b,n);

 printf("    (%.3lf\n", a);
 printf(" int(   2 * Pi (%s) [(%s) - (%s)] dx = %.12lf\n",
                        heq,   feq,   geq,       M);
 printf("    (%.3lf\n", b);

 printf("\n Press return to continue");
 getchar();

 return 0;
}

